{без длинной арифметики - не для всех тестов}

{$N+}

const
  NMAX = 100;
  MMAX = 3;

var
  N,M: Integer;
  k,i: Integer;
  s: array[0..NMAX] of Comp;


begin

  readln(N,M);
  if odd(N) then begin
    writeln(0);
    exit;
  end;
  N := N div 2;
  fillchar(s,sizeof(s),0);
  s[0]:=1;
  for k:=1 to N do
    for i:=1 to k do s[k]:=s[k]+M*s[i-1]*s[k-i];

  writeln(s[N]:0:0);

end.
